package cz.muni.fi.pb162.test2;

import junit.framework.TestCase;

/**
 *
 * @author petr
 */
public class TrainTest extends TestCase {
    
    public TrainTest(String testName) {
        super(testName);
    }
    
    public void testLocomotionGetLength() {
        Locomotive locomotive = new Locomotive(16);
        assertEquals(16.0,locomotive.getLength());
        locomotive = new Locomotive(8);
        assertEquals(8.0,locomotive.getLength());
    }

    public void testLocomotionToString() {
        Locomotive locomotive = new Locomotive(16);
        assertEquals("Locomotive (length: 16.0)",locomotive.toString());
        locomotive = new Locomotive(4);
        assertEquals("Locomotive (length: 4.0)",locomotive.toString());
    }

    public void testCarriageGetLength() {
        Carriage carriage = new Carriage(16);
        assertEquals(16.0,carriage.getLength());
        carriage = new Carriage(32);
        assertEquals(32.0,carriage.getLength());
    }

    public void testCarriageToString() {
        Carriage carriage = new Carriage(16);
        assertEquals("Carriage (length: 16.0)",carriage.toString());
        carriage = new Carriage(32);
        assertEquals("Carriage (length: 32.0)",carriage.toString());
    }

    public void testTrainGetLength() {
        Carriage carriage = new Carriage(8);
        Locomotive locomotive = new Locomotive(16);
        Train train = new Train(locomotive,carriage,10);
        assertEquals(96.0,train.getLength());

        carriage = new Carriage(16);
        locomotive = new Locomotive(32);
        train = new Train(locomotive,carriage,5);
        assertEquals(112.0,train.getLength());
    }

    public void testTrainToString() {
        Carriage carriage = new Carriage(8);
        Locomotive locomotive = new Locomotive(16);
        Train train = new Train(locomotive,carriage,10);
        assertEquals("Train (length: 96.0) [Locomotive (length: 16.0)," +
                " 10 x Carriage (length: 8.0)]",train.toString());

        carriage = new Carriage(16);
        locomotive = new Locomotive(32);
        train = new Train(locomotive,carriage,5);
        assertEquals("Train (length: 112.0) [Locomotive (length: 32.0)," +
                " 5 x Carriage (length: 16.0)]",train.toString());
    }

    public void testClassHierarchy(int number) {
        assertEquals(AbstractVehicle.class,Locomotive.class.getSuperclass());
        assertEquals(AbstractVehicle.class,Carriage.class.getSuperclass());
        assertFalse(AbstractVehicle.class.isAssignableFrom(Train.class));
        assertFalse(Train.class.isAssignableFrom(AbstractVehicle.class));
        assertFalse(Carriage.class.isAssignableFrom(Locomotive.class));
        assertFalse(Locomotive.class.isAssignableFrom(Carriage.class));
        assertTrue(Vehicle.class.isAssignableFrom(AbstractVehicle.class));
        assertTrue(Vehicle.class.isAssignableFrom(Carriage.class));
        assertTrue(Vehicle.class.isAssignableFrom(Locomotive.class));
        assertTrue(Vehicle.class.isAssignableFrom(Train.class));
    }

}
